#ifndef __BSP_USARTX_FIFO_H__
#define __BSP_USARTX_FIFO_H__

/* ͷļ ----------------------------------------------------------------*/
#include "stm32f1xx_hal.h"
#include <stdio.h>
#include "string.h"

/* Ͷ ------------------------------------------------------------------*/
/* ˿ں */
typedef enum
{
	COM1 = 0,	/* USART1 */
	COM2 = 1,	/* USART2 */
	COM3 = 2,	/* USART3 */
}COM_PORT_E;

/* 豸ṹ */
typedef struct
{
	USART_TypeDef *usart;              /* STM32ڲ豸ָ */
	uint8_t *pTxBuf;                   /* ͻ */
	uint8_t *pRxBuf;                   /* ջ */
	uint16_t usTxBufSize;              /* ͻС */
	uint16_t usRxBufSize;              /* ջС */
	__IO uint16_t usTxWrite;           /* ͻдָ */
	__IO uint16_t usTxRead;            /* ͻָ */
	__IO uint16_t usTxCount;           /* ȴ͵ݸ */

	__IO uint16_t usRxWrite;           /* ջдָ */
	__IO uint16_t usRxRead;            /* ջָ */
	__IO uint16_t usRxCount;           /* δȡݸ */

	void (*SendBefor)(void);           /* ʼ֮ǰĻصָ루ҪRS485лģʽ */
	void (*SendOver)(void);            /* ϵĻصָ루ҪRS485ģʽлΪģʽ */
	void (*ReciveNew)(uint8_t _byte);  /* յݵĻصָ */
}USART_FIFO_Typedef;

/* 궨 --------------------------------------------------------------------*/
#define	USART1_FIFO_EN                     	         1
#define	USART2_FIFO_EN                     	         0
#define	USART3_FIFO_EN                     	         0

#define DISABLE_INT()                                { __set_PRIMASK(1); }	/* ж */
#define ENABLE_INT()                                 { __set_PRIMASK(0); }	/* ж */

#if USART1_FIFO_EN == 1
	#define USART1_BAUD			                    115200
	#define USART1_TX_BUF_SIZE	                1*1024
	#define USART1_RX_BUF_SIZE	                1*1024
#endif

#if USART2_FIFO_EN == 1
	#define USART2_BAUD			                    115200
	#define USART2_TX_BUF_SIZE	                1*1024
	#define USART2_RX_BUF_SIZE	                1*1024
#endif

#if USART3_FIFO_EN == 1
	#define USART3_BAUD			                    9600
	#define USART3_TX_BUF_SIZE	                1*1024
	#define USART3_RX_BUF_SIZE	                1*1024
#endif

/* չ ------------------------------------------------------------------*/
extern UART_HandleTypeDef husart_debug;

/*  ------------------------------------------------------------------*/
void comSendBuf(COM_PORT_E _ucPort, uint8_t *_ucaBuf, uint16_t _usLen);
void comSendChar(COM_PORT_E _ucPort, uint8_t _ucByte);
uint8_t comGetChar(COM_PORT_E _ucPort, uint8_t *_pByte);

void comClearTxFifo(COM_PORT_E _ucPort);
void comClearRxFifo(COM_PORT_E _ucPort);
void Usart_FIFO_Init(void);


#endif  // __BSP_USARTX_FIFO_H__

/******************* (C) COPYRIGHT 2015-2020 ӲʯǶʽŶ *****END OF FILE****/
